/****************************************************************
* Modul:   TA.BA_MMT.HS1301 - Multimedia Technik (MMT)
* Subject: Processing - Uebung 8 - Pop-Art
* Author:  Felix Rohrer
* Desc:    Komplementärfarben, Pop-Art Bild nach Andy Warhol
****************************************************************/

PImage img;
color colOrg;
color colComp;
boolean moreRed;
boolean moreGreen;
boolean moreBlue;

int step = 5; // change Color

// ----- setup() ------------------------------------------------
void setup()
{
  //size(400, 196); // Lotus_Elise
  size(460, 150); // Lotus-Elise-Profile
  background(255);
  frameRate(20);
  
  //img = loadImage("Lotus_Elise.jpg"); // 400, 196
  img = loadImage("lotus-elise-profile.jpg");
  //img = loadImage("/wp-content/uploads/lotus-elise-profile.jpg"); // 460, 150
  
  // random start color
  colOrg = color(random(255), random(255), random(255));
}


// ----- draw() -------------------------------------------------
void draw()
{
  loadPixels(); // used for accessing each pixel 
  img.loadPixels();
  
  float r = colOrg >> 16 & 0xFF; //red(colOrg);
  float g = colOrg >> 8 & 0xFF; //green(colOrg);
  float b = colOrg & 0xFF; //blue(colOrg);
  
  // color 0 .. 255
  if (moreRed && r >= 250) { moreRed = false;} 
  else if (!moreRed && r <= 5) { moreRed = true; }
  
  if (moreGreen && g >= 250) { moreGreen = false; }
  else if (!moreGreen && g <= 5){ moreGreen = true; }
  
  if (moreBlue && b >= 250) { moreBlue = false; }
  else if (!moreBlue && b <= 5) { moreBlue = true; }
  
  // calc new Color  
  float red   = moreRed   ? r + step : r - step;
  float green = moreGreen ? g + step : g - step;
  float blue  = moreBlue  ? b + step : b - step;
  
  // get current & complement Color
  colOrg  = color(red, green, blue);
  colComp = color(255 - red, 255 - green, 255 - blue);  

  //Processing 1-D image array
  for (int y = 0; y < height; y++) {
    for (int x = 0; x < width; x++) {
      int loc = x + y * width; // calc new position/pixel
      
      color pixelColor = img.pixels[loc]; // get one Pixel

      if (pixelColor > color(50,50,50)) { // 50 -> gray-Colors
        pixels[loc] = colOrg;  } // use normal color
      else {
        pixels[loc] = colComp; // use complement color
      }
    }
  }
  
  updatePixels(); // update display
}
